#ifndef CHESSY_TRANSPOSITIONTABLE_H
#define CHESSY_TRANSPOSITIONTABLE_H
#include <array>
#include <cinttypes>

#include "Bitboard.h"

namespace chessy
{
    using HashValue = uint64_t;
    class TranspositionTable;

    // forward declaration
    class ChessGame;
}


namespace chessy
{
    namespace zobrist
    {
        extern std::array<HashValue, 64 * 12> pieces;
        extern std::array<HashValue, 16> castlingRights;
        extern std::array<HashValue, 8> enPassant;
        extern HashValue turn;

        HashValue getHash(const ChessGame&);

        inline HashValue get(PieceType p, Side side, Index i)
        {
            return pieces[(static_cast<int>(p) + side * 6) * 64 + i];
        }

        void initialize(void);
    }
}


class chessy::TranspositionTable
{

};

#endif //CHESSY_TRANSPOSITIONTABLE_H

